## bird3 3.1.0

=== doc/Makefile ===
# Force rebuilds
.PHONY: progspell docs progdocs userdocs

doc-srcdir := $(realpath $(srcdir)/doc)
toolsdir := $(realpath $(srcdir)/tools)

docs: progdocs userdocs

doc-fmt = $(1): $(o)prog.$(1) $(o)bird.$(1)
$(call doc-fmt,html)
$(call doc-fmt,dvi)
$(call doc-fmt,ps)
$(call doc-fmt,pdf)

progdocs: $(o)prog.html $(o)prog.pdf
userdocs: $(o)bird.html $(o)bird.pdf
progspell: $(o)prog.spell

$(o)prog.sgml: $(srcdir)/tools/progdoc $(objdir)/.dir-stamp
	$(srcdir)/tools/progdoc $(srcdir) $@

$(o)%.sgml: $(s)%.sgml $(objdir)/.dir-stamp
	cp $< $@

$(o)%.html: $(o)%.sgml
	cd $(dir $@) && $(toolsdir)/linuxdoc -B html $(notdir $<)

ifeq ($(PANDOC),)
$(o)%.md: $(s)%.sgml
	@echo "ERROR: No pandoc available, install pandoc to build documentation"
	@false
else
LINUXDOC_PANDOC_PARSER := $(srcdir)/tools/linuxdoc.lua
$(o)%.md: $(s)%.sgml $(LINUXDOC_PANDOC_PARSER) $(objdir)/.dir-stamp
	$(PANDOC) -f $(LINUXDOC_PANDOC_PARSER) -s -t markdown -o $@ $<

$(o)%-singlepage.html: $(o)%.md
	$(PANDOC) -f markdown -t html5 -s -o $@ $<

endif

$(o)%.tex: $(o)%.sgml
	cd $(dir $@) && $(toolsdir)/linuxdoc -B latex --output=tex $(notdir $<)

$(o)%.dvi: $(o)%.tex
	cd $(dir $@) && TEXINPUTS=$(TEXINPUTS):$(doc-srcdir)/tex latex $(notdir $<)
	cd $(dir $@) && TEXINPUTS=$(TEXINPUTS):$(doc-srcdir)/tex latex $(notdir $<)

$(o)%.ps: $(o)%.dvi
	dvips -D600 -ta4 -o $@ $<

$(o)%.pdf: $(o)%.tex
	TEXINPUTS=$(TEXINPUTS):$(doc-srcdir)/tex pdflatex -output-directory=$(dir $@) $<
	TEXINPUTS=$(TEXINPUTS):$(doc-srcdir)/tex pdflatex -output-directory=$(dir $@) $<

$(o)%.txt: $(o)%.sgml
	cd $(dir $@) && $(toolsdir)/linuxdoc -B txt $(notdir $<)

$(o)prog.spell: $(o)prog.sgml $(s)prog-spell.sed
	sed -f $(lastword $^) <$< >$@
	ispell $@

$(call clean,prog.spell $(addprefix *.,html dvi ps pdf sgml tex txt aux log toc))

=== doc/threads/Makefile ===
SUFFICES := .pdf -wordpress.html
CHAPTERS := 00_the_name_of_the_game 01_the_route_and_its_attributes 02_asynchronous_export 03_coroutines 03b_performance

all: $(foreach ch,$(CHAPTERS),$(addprefix $(ch),$(SUFFICES)))

00_the_name_of_the_game.pdf: 00_filter_structure.png

%.pdf: %.md
	pandoc -f markdown -t latex -o $@ $<

%.html: %.md
	pandoc -f markdown -t html5 -o $@ $<

%-wordpress.html: %.html Makefile
	sed -r 's#</p>#\n#g; s#<p>##g; s#<(/?)code>#<\1tt>#g; s#<pre><tt>#<code>#g; s#</tt></pre>#</code>#g; s#</?figure>##g; s#<figcaption>#<p style="text-align: center">#; s#</figcaption>#</p>#; ' $< > $@

stats-%.csv: stats.csv stats-filter.pl
	perl stats-filter.pl $< $* > $@

STATS_VARIANTS := multi imex mulimex single
stats-all: $(patsubst %,stats-%.csv,$(STATS_VARIANTS))

stats-2d-%.pdf: stats.csv stats-filter-2d.pl
	perl stats-filter-2d.pl $< $* $@

stats-2d-%.png: stats-2d-%.pdf
	gs -dBATCH -dNOPAUSE -sDEVICE=pngalpha -sOutputFile=$@ -r300 $<

stats-all-2d: $(foreach suf,pdf png,$(patsubst %,stats-2d-%.$(suf),$(STATS_VARIANTS)))

=== debian/changelog ===
bird3 (3.1.0-1) unstable; urgency=medium

  * Upload to unstable (Closes: #1090749: ITP bird3)
  * New upstream version 3.1.0

 -- Jakub Ružička <jru@debian.org>  Thu, 03 Apr 2025 23:14:39 +0200

bird3 (3.0.1-1) experimental; urgency=medium

  * New upstream version
  * Add lib/blake2* to debian/copyright
  * Update copyright years for active contributors

 -- Jakub Ružička <jru@debian.org>  Tue, 28 Jan 2025 13:19:22 +0100

bird3 (3.0.0-1) experimental; urgency=medium

  * Initial 3.0.0 packaging

 -- Jakub Ružička <jru@debian.org>  Tue, 17 Dec 2024 15:31:29 +0100

=== debian/watch ===
version=4
https://bird.network.cz/download/bird-(3\.[\d.]+).tar.gz

## bird3 3.1.4

=== filter/Makefile ===
src := filter.c data.c f-util.c tree.c trie.c inst-gen.c
obj := $(src-o-files)
$(all-daemon)
$(cf-local)

#M4FLAGS_FILTERS=$(filter-out -s,$(M4FLAGS))
M4FLAGS_FILTERS=$(M4FLAGS)

$(o)inst-gen.h: $(s)decl.m4 $(s)f-inst.c $(objdir)/.dir-stamp
	$(M4) $(M4FLAGS_FILTERS) -DTARGET=H -P $^ >$@

$(o)inst-gen.c: $(s)decl.m4 $(s)f-inst.c $(objdir)/.dir-stamp
	$(M4) $(M4FLAGS_FILTERS) -DTARGET=C -P $^ >$@

$(o)inst-interpret.c: $(s)decl.m4 $(s)f-inst.c $(objdir)/.dir-stamp
	$(M4) $(M4FLAGS_FILTERS) -DTARGET=I -P $^ >$@

prepare: $(o)inst-interpret.c $(o)inst-gen.h

tests_src := tree_test.c trie_test.c
ifeq ($(findstring bgp,$(protocols))-$(findstring static,$(protocols)),bgp-static)
	tests_src += filter_test.c
endif
tests_targets := $(tests_targets) $(tests-target-files)
tests_objs := $(tests_objs) $(src-o-files)

$(call clean,inst-gen.h inst-gen.c inst-interpret.c)

=== lib/Makefile ===
src := a-path.c a-set.c bitmap.c bitops.c blake2s.c blake2b.c checksum.c defer.c event.c flowspec.c idm.c ip.c lists.c lockfree.c mac.c md5.c mempool.c net.c netindex.c patmatch.c printf.c rcu.c resource.c sha1.c sha256.c sha512.c slab.c slists.c strtoul.c tbf.c timer.c xmalloc.c
obj := $(src-o-files)
$(all-daemon)

tests_src := a-set_test.c a-path_test.c attribute_cleanup_test.c bitmap_test.c heap_test.c buffer_test.c event_test.c flowspec_test.c bitops_test.c patmatch_test.c fletcher16_test.c slist_test.c rt-normalize_test.c checksum_test.c lists_test.c locking_test.c mac_test.c ip_test.c hash_test.c printf_test.c rcu_test.c slab_test.c tlists_test.c type_test.c
tests_targets := $(tests_targets) $(tests-target-files)
tests_objs := $(tests_objs) $(src-o-files)

=== nest/Makefile ===
src := cli.c cmds.c iface.c locks.c mpls.c neighbor.c password.c proto.c proto-build.c rt-attr.c rt-dev.c rt-export.c rt-fib.c rt-show.c rt-table.c
obj := $(src-o-files)
$(all-daemon)
$(cf-local)
$(conf-y-targets): $(s)mpls.Y

$(o)proto-build.c: Makefile $(lastword $(MAKEFILE_LIST)) $(objdir)/.dir-stamp
	$(E)echo GEN $@
	$(Q)( P='$(PROTO_BUILD)' && printf "void %s_build(void);\n" $$P && printf "\nvoid\nprotos_build_gen(void)\n{\n" && printf "  %s_build();\n" $$P && printf "}\n" ) > $@

prepare: $(o)proto-build.c

tests_src := rt-fib_test.c
tests_targets := $(tests_targets) $(tests-target-files)
tests_objs := $(tests_objs) $(src-o-files)

=== proto/bfd/Makefile ===
src := bfd.c packets.c
obj := $(src-o-files)
$(all-daemon)
$(cf-local)

tests_objs := $(tests_objs) $(src-o-files)

=== proto/bmp/Makefile ===
src := bmp.c
obj := $(src-o-files)
$(all-daemon)
$(cf-local)

tests_objs := $(tests_objs) $(src-o-files)

=== proto/l3vpn/Makefile ===
src := l3vpn.c
obj := $(src-o-files)
$(all-daemon)
$(cf-local)

tests_objs := $(tests_objs) $(src-o-files)

=== proto/mrt/Makefile ===
src := mrt.c
obj := $(src-o-files)
$(all-daemon)
$(cf-local)

tests_objs := $(tests_objs) $(src-o-files)

=== proto/pipe/Makefile ===
src := pipe.c
obj := $(src-o-files)
$(all-daemon)
$(cf-local)

tests_objs := $(tests_objs) $(src-o-files)

=== proto/rip/Makefile ===
src := packets.c rip.c
obj := $(src-o-files)
$(all-daemon)
$(cf-local)

tests_objs := $(tests_objs) $(src-o-files)

=== proto/rpki/Makefile ===
src := rpki.c packets.c tcp_transport.c ssh_transport.c transport.c
obj := $(src-o-files)
$(all-daemon)
$(cf-local)

tests_objs := $(tests_objs) $(src-o-files)

=== proto/static/Makefile ===
src := static.c
obj := $(src-o-files)
$(all-daemon)
$(cf-local)

tests_objs := $(tests_objs) $(src-o-files)

=== sysdep/bsd/Makefile ===
src := krt-sock.c
obj := $(src-o-files)
$(all-daemon)
$(conf-y-targets): $(s)krt-sock.Y

tests_objs := $(tests_objs) $(src-o-files)

=== debian/changelog ===
bird3 (3.1.4-1) unstable; urgency=medium

  * New upstream version
  * Update debian/watch for new BIRD download URL

 -- Jakub Ružička <jru@debian.org>  Fri, 26 Sep 2025 16:02:52 +0200

=== debian/control ===
Source: bird3
Section: net
Priority: optional
Build-Depends:
 bison,
 ca-certificates,
 debhelper-compat (= 13),
 docbook-xsl,
 flex,
 libncurses-dev,
 libreadline-dev | libreadline6-dev | libreadline5-dev,
 libssh-dev,
 m4,
 quilt,
 xsltproc,
Build-Depends-Indep:
 linuxdoc-tools-latex,
 opensp,
 texlive-latex-extra,
Maintainer: Jakub Ružička <jru@debian.org>
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/bird3
Vcs-Git: https://salsa.debian.org/debian/bird3.git
Homepage: https://bird.network.cz/
Rules-Requires-Root: no

Package: bird3
Architecture: kfreebsd-any linux-any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 adduser,
 ucf,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 bird,
 bird2,
Suggests:
 bird3-doc,
Description: Internet Routing Daemon
 BIRD is an Internet routing daemon with full support for all the major
 routing protocols. It allows redistribution between protocols with a
 powerful route filtering syntax and an easy-to-use configuration
 interface.
 .
 BIRD supports IPv4 and IPv6 versions of OSPF, RIP, BGP and Babel routing
 protocols. It also supports supplementary protocols like BFD, RPKI-Router
 and IPv6 router advertisements.

Package: bird3-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Description: Internet Routing Daemon - documentation
 BIRD is an Internet routing daemon with full support for all the major
 routing protocols. It allows redistribution between protocols with a
 powerful route filtering syntax and an easy-to-use configuration
 interface.
 .
 This package provides the user and developer documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

COMMON_FLAGS= --prefix=/usr --sysconfdir=/etc/bird --mandir=\$${prefix}/share/man \
	--infodir=\$${prefix}/share/info --localstatedir=/var --runstatedir=/run/bird \
	--docdir=\$${prefix}/share/bird3 \
	--enable-client

CFLAGS += -g -O2 -fno-strict-aliasing -fno-strict-overflow -fPIC
LDFLAGS += -g -O2 -fno-strict-aliasing -fno-strict-overflow -fPIC -Wl,-z,defs -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" dh_auto_configure -- $(COMMON_FLAGS) --with-protocols=all

override_dh_auto_build-indep:
	dh_auto_build -- docs

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

override_dh_installinit:
	dh_installinit --name=bird --restart-after-upgrade

override_dh_installsystemd:
	dh_installsystemd --name=bird --restart-after-upgrade

DB2MAN = /usr/share/sgml/docbook/stylesheet/xsl/nwalsh/manpages/docbook.xsl
XP     = xsltproc -''-nonet -''-param man.charmap.use.subset "0"

bird.8: debian/bird.xml
	$(XP) $(DB2MAN) $<

override_dh_installman: bird.8
	dh_installman

override_dh_clean:
	dh_clean
	-rm -f bird.8 birdc.8 birdcl.8

override_dh_missing:
	dh_missing

override_dh_compress:
	dh_compress -X.conf

=== debian/tests/control ===
Tests: test-bird.sh
Restrictions: needs-root
Depends:
 bird3,

=== debian/watch ===
version=4
https://bird.nic.cz/download/ bird-(3\.[\d.]+).tar.gz

## bird3 3.1.5

=== doc/slides/Makefile ===
all: slides.dvi

slides.dvi: slides.tex
	csplain slides.tex

slides.ps: slides.dvi
	dvips -o slides.ps -D600 -ta4 slides.dvi

view: slides.dvi
	xdvi -expert -geometry 1100x700 -l -s 4 -paper a4 -margins 1in slides.dvi

viewlarge: slides.dvi
	xdvi -expert -geometry 1024x700 -l -s 1 -paper a4 -margins 1in slides.dvi

viewreal: slides.dvi
	xdvi -expert -geometry 1024x700 -l -s 6 -paper a4 -margins 1in slides.dvi

clean:
	rm -f *~ *.log *.tfm *.*pk *.*gf *.ps *.dvi

=== debian/changelog ===
bird3 (3.1.5-2) unstable; urgency=medium

  * bird.service: fix the Environment directive.

 -- Marco d'Itri <md@linux.it>  Thu, 18 Dec 2025 20:57:00 +0100

bird3 (3.1.5-1) unstable; urgency=medium

  * New upstream release.
  * New maintainer.
  * Use Restart=on-abnormal instead of on-abort. (Closes: #1099513)
  * Do not install an example /etc/bird/bird.conf anymore, because there
    is no useful BIRD configuration that can be enabled by default.
  * Create /etc/bird/ with standard permissions: the local admin can
    use appropriate permission for bird.conf if access to it needs to
    be restricted.
  * Create the bird user with no home directory for added security.

 -- Marco d'Itri <md@linux.it>  Wed, 17 Dec 2025 14:51:37 +0100

=== debian/control ===
--- 
+++ 
@@ -5,32 +5,29 @@
  bison,
  ca-certificates,
  debhelper-compat (= 13),
+ dh-sequence-installsysusers,
  docbook-xsl,
  flex,
  libncurses-dev,
- libreadline-dev | libreadline6-dev | libreadline5-dev,
+ libreadline-dev,
  libssh-dev,
  m4,
- quilt,
  xsltproc,
 Build-Depends-Indep:
  linuxdoc-tools-latex,
  opensp,
  texlive-latex-extra,
-Maintainer: Jakub Ružička <jru@debian.org>
-Standards-Version: 4.7.0
-Vcs-Browser: https://salsa.debian.org/debian/bird3
-Vcs-Git: https://salsa.debian.org/debian/bird3.git
+Maintainer: Marco d'Itri <md@linux.it>
+Standards-Version: 4.7.2.0
+Vcs-Browser: https://salsa.debian.org/md/bird
+Vcs-Git: https://salsa.debian.org/md/bird.git -b debian/bird3/unstable
 Homepage: https://bird.network.cz/
-Rules-Requires-Root: no
 
 Package: bird3
-Architecture: kfreebsd-any linux-any
+Architecture: linux-any
 Pre-Depends:
  ${misc:Pre-Depends},
 Depends:
- adduser,
- ucf,
  ${misc:Depends},
  ${shlibs:Depends},
 Conflicts:
@@ -50,6 +47,7 @@
 
 Package: bird3-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends:
  ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# enable verbose messages from the Makefiles
export VERBOSE=1

COMMON_FLAGS=\
	--prefix=/usr \
	--sysconfdir=/etc/bird \
	--mandir=\$${prefix}/share/man \
	--infodir=\$${prefix}/share/info \
	--localstatedir=/var \
	--runstatedir=/run/bird \
	--docdir=\$${prefix}/share/bird3 \
	--enable-client --with-protocols=all

DB2MAN = /usr/share/sgml/docbook/stylesheet/xsl/nwalsh/manpages/docbook.xsl
XP     = xsltproc -''-nonet -''-param man.charmap.use.subset "0"

%:
	dh $@

override_dh_auto_configure:
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	dh_auto_configure -- $(COMMON_FLAGS)

override_dh_auto_build-indep:
	dh_auto_build -- docs

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

override_dh_installsystemd:
	dh_installsystemd --name=bird --restart-after-upgrade

bird.8: debian/bird.xml
	$(XP) $(DB2MAN) $<

override_dh_installman: bird.8
	dh_installman

## bird3 3.2.0

=== debian/changelog ===
bird3 (3.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Marco d'Itri <md@linux.it>  Sun, 04 Jan 2026 20:10:22 +0100

=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,6 @@
 	dh $@
 
 override_dh_auto_configure:
-	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
 	dh_auto_configure -- $(COMMON_FLAGS)
 
 override_dh_auto_build-indep:

=== debian/watch ===
Version: 5

Source: https://bird.nic.cz/download/
Matching-Pattern: bird-(3\.[\d.]+).tar.gz
